local AddName, Ns = ...
local L = Ns.L


----------------------------
-- Local Helper Functions --
----------------------------

function Ns.StatsCompute()

	-- Init
	Ns.combustion, Ns.serenity, Ns.overflowEnergy, Ns.luckOfDraw = 0, 0, 0, 0
	Ns.hitCombo, Ns.shadowForm, Ns.loneWolf, Ns.runePower = 0, 0, 0, 0
	Ns.incanterFlow, Ns.demonSoul, Ns.tigersFury, Ns.momentum = 0, 0, 0, 0
	Ns.touchOfIce, Ns.demonicSynergy, Ns.seethChaos, Ns.equilibrium = 0, 0, 0, 0
	Ns.iridescence = 0

	for i = 1, 40 do
		local _, _, count, _, _, _, caster, _, _, spellId = UnitBuff("player",i, "HELPFUL")
		if not spellId then break end	
	
		if Ns.Combustion[spellId] then Ns.combustion = Ns.Combustion[spellId][1] end
		if Ns.Serenity[spellId] then Ns.serenity = Ns.Serenity[spellId][1] end
		if Ns.Overflowing[spellId] then Ns.overflowEnergy = count * 2 end
		if Ns.LuckOfTheDraw[spellId] then Ns.luckOfDraw = ((count * 5) / 100 ) end
		if Ns.HitCombo[spellId] then Ns.hitCombo = count end
		if Ns.Shadowform[spellId] then Ns.shadowForm = Ns.Shadowform[spellId][1] end
		if Ns.LoneWolf[spellId] then Ns.loneWolf = Ns.LoneWolf[spellId][1] end
		if Ns.RuneOfPower[spellId] then Ns.runePower = Ns.RuneOfPower[spellId][1] end
		if Ns.DemonSoul[spellId] then Ns.demonSoul = Ns.DemonSoul[spellId][1] end
		if Ns.TigersFury[spellId] then Ns.tigersFury = Ns.TigersFury[spellId][1] end
		if Ns.Momentum[spellId] then Ns.momentum = Ns.Momentum[spellId][1] end
		if Ns.TouchOfIce[spellId] then Ns.touchOfIce = Ns.TouchOfIce[spellId][1] end
		if Ns.SeethChaos[spellId] then Ns.seethChaos = Ns.SeethChaos[spellId][1] end
		if Ns.DemonicSynergy[spellId] then Ns.demonicSynergy = Ns.DemonicSynergy[spellId][1] end
		if Ns.IncanterFlow[spellId] then Ns.incanterFlow = count * 4 end
		if Ns.ElementalEquilibrium[spellId] then Ns.equilibrium = Ns.Equilibrium end
		if Ns.Iridescence[spellId] then Ns.iridescence = Ns.Iridescence[spellId][1] end		
	end
end 

--------------------------------------
--		Global OnEvent function		--
--------------------------------------
function Ns.OnEventFunc(event, ...)

	if event == "PLAYER_TARGET_CHANGED" then
	-----	
		local exists = UnitExists("target")
		local hostile = UnitCanAttack("player", "target")
	
		if hostile or not exists then Ns.SinLive() end
	-----
	elseif event == "UPDATE_FACTION" then
	-----
		local currentXP = C_MajorFactions.GetMajorFactionData(2564)
		Ns.percentLoamm = 0
		if currentXP == nil then currentXP = 0 end
		Ns.percentLoamm = currentXP.renownReputationEarned
		Ns.percentLoamm = (Ns.percentLoamm * 0.04)
	-----
	elseif event == "TRAIT_CONFIG_UPDATED" then
		Ns.talentScan()
	-----	
	else
	-----	
	
	-- SinLive
	local unit = ...
	if unit == "target" then Ns.SinLive() return end
	
	Ns.StatsCompute()
	
end -- end events
end -- end function